#include "GPIOPin.h"
#include "GPIOAccess.h"

GPIOPin::GPIOPin(int pinNum)
{
    pinNumber = pinNum;
}

GPIOPin::~GPIOPin(void)
{
    stopPWM();
}

GPIO_Result GPIOPin::setDirection(GPIO_Direction dir)
{
    return GPIOAccess::setDirection(pinNumber, dir);
}

GPIO_Result GPIOPin::getDirection(GPIO_Direction &dir)
{
    return GPIOAccess::getDirection(pinNumber, dir);
}

GPIO_Direction GPIOPin::getDirection()
{
    GPIO_Direction dir;
    GPIOAccess::getDirection(pinNumber, dir);
    return dir;
}

GPIO_Result GPIOPin::set(int value)
{
    if (GPIOAccess::isPWMRunning(pinNumber)) {
        return GPIO_INVALID_OP;
    }
    return GPIOAccess::set(pinNumber, value);
}

GPIO_Result GPIOPin::get(int &value)
{
    return GPIOAccess::get(pinNumber, value);
}

int GPIOPin::get()
{
    int value;
    GPIOAccess::get(pinNumber, value);
    return value;
}

GPIO_Result GPIOPin::setPWM(int freq, int duty) {
    return GPIOAccess::setPWM(pinNumber, freq, duty);
}

GPIO_Result GPIOPin::startPWM() {
    return GPIOAccess::startPWM(pinNumber);
}

GPIO_Result GPIOPin::stopPWM() {
    return GPIOAccess::stopPWM(pinNumber);
}

int GPIOPin::getPWMFreq() {
    return GPIOAccess::getPWMFreq(pinNumber);
}

int GPIOPin::getPWMDuty() {
    return GPIOAccess::getPWMDuty(pinNumber);
}

bool GPIOPin::isPWMRunning() {
    return GPIOAccess::isPWMRunning(pinNumber);
}

int GPIOPin::getPinNumber() {
    return pinNumber;
}
