#ifndef GPIOPin_h
#define GPIOPin_h

#include <pthread.h>
#include "GPIOTypes.h"

class GPIOPin {
public:
    GPIOPin(int pinNum);
    ~GPIOPin(void);

    GPIO_Result setDirection(GPIO_Direction dir);
    GPIO_Result getDirection(GPIO_Direction &dir);
    GPIO_Direction getDirection();

    GPIO_Result set(int value);
    GPIO_Result get(int &value);
    int get();

    GPIO_Result setPWM(int freq, int duty);
    GPIO_Result startPWM();
    GPIO_Result stopPWM();
    
    int getPWMFreq();
    int getPWMDuty();
    bool isPWMRunning();

    int getPinNumber();
private:
    int pinNumber;
};

#endif
